go mod 使用及问题笔记

写过不少的go工程,从go vetglide再到go dep,一直用到最新的go1.11的新特性go mod,可以说go mod已经时我用过最好的版本管理工具了,但是目前仍处在实验阶段,里面也有不少坑,当遇到问题是要自己解决,当工程多了以后很容易进入依赖地狱。

如果不想折腾,最好的办法还是将vendor一起传到代码库里,一劳永逸。

问题1:

mesher工程依赖于go-chassis工程,都使用go mod进行管理,当我尝试运行mesher的go mod时,错误如下

  1. github.com/go-chassis/go-chassis@v0.8.4-0.20180925045504-56298faf2ce6: parsing go.mod: go.mod:24: invalid module version "master": version must be of the form v1.2.3

实际上是go chassis工程的go.mod定义有问题,其中一个依赖的版本定义为master,我大意的将这个定义传到了代码库:

  1. github.com/go-chassis/paas-lager master

而这在go mod中实际上不允许的,需要使用go mod命令自动生成版本后推到代码库

  1. github.com/go-chassis/paas-lager v0.0.0-20180905100939-eff93e5e67db

当某个依赖go chassis的库也定义了go.mod,里面定义了go chassis时。就会出问题。

ft_authoradmin  ft_create_time2019-04-26 17:56
 ft_update_time2019-04-26 17:57